-- name: [CS] \\#00AAFF\\Yumpi
-- description: \\#DCDCDC\\Play as the tiny version of Yumi,\n\\#00AAFF\\Yumpi\\#DCDCDC\\!\n\n\\#00AAFF\\Yumpi\\#DCDCDC\\Model by x\\#00FF00\\Luigi\\#434343\\Gamer\\#DCDCDC\\x\n\\#00AAFF\\Yumpi\\#DCDCDC\\ OC by frijoles.z64\n\\#00AAFF\\Yumpi\\#DCDCDC\\ V2 design based on the new Yumi\nby KeysArtwork

local function split(str, delim, maxNb)
    -- Eliminate bad cases...
    if string.find(str, delim) == nil then
       return { str }
    end
    if maxNb == nil or maxNb < 1 then
       maxNb = 0    -- No limit
    end
    local result = {}
    local pat = "(.-)" .. delim .. "()"
    local nb = 0
    local lastPos
    for part, pos in string.gmatch(str, pat) do
       nb = nb + 1
       result[nb] = part
       lastPos = pos
       if nb == maxNb then
          break
       end
    end
    -- Handle the last field
    if nb ~= maxNb then
       result[nb + 1] = string.sub(str, lastPos)
    end
    return result
end

---@param name string|nil Underscores turn into Spaces
---@param description string|nil FUCK TABLES, use \n to break lines
---@param credit string|nil
---@param color Color|nil {r, g, b}
---@param modelInfo ModelExtendedId|integer|nil Use smlua_model_util_get_id()
---@param forceChar CharacterType|nil CT_MARIO, CT_LUIGI, CT_TOAD, CT_WALUIGI, CT_WARIO
---@param lifeIcon TextureInfo|nil Use get_texture_info()
---@param camScale integer|nil Zooms the camera based on a multiplier (Default 1.0)
local function character_add(name, description, credit, color, modelInfo, forceChar, lifeIcon, camScale)
    descriptionSplit = split(description, "\n")
    charSelect.character_add(name, descriptionSplit, credit, color, modelInfo, forceChar, lifeIcon, camScale)
end

local E_MODEL_YUMPI = smlua_model_util_get_id("yumpi_geo")

local TEX_YUMPI = get_texture_info("yumpi-icon")

-- I was too lazy to rename the sound files but they're Yumpi's so dw about it
local VOICETABLE_YUMPI = {
    [CHAR_SOUND_ATTACKED] = 'Yumi Voicelines - Yumi Ow.ogg',
    [CHAR_SOUND_DOH] = 'Yumi Voicelines - Yumi Single Jump 3.ogg',
    [CHAR_SOUND_DYING] = 'Yumi Voicelines - Yumi Mamamia.ogg',
    [CHAR_SOUND_EEUH] = 'Yumi Voicelines - Yumi Uh 3.ogg',
    [CHAR_SOUND_GAME_OVER] = 'Yumi Voicelines - Yumi Mamamia.ogg',
    [CHAR_SOUND_GROUND_POUND_WAH] = 'Yumi Voicelines - Yumi Single Jump 3.ogg',
    [CHAR_SOUND_HAHA] = 'Yumi Voicelines - Yumi Haha.ogg',
    [CHAR_SOUND_HAHA_2] = 'Yumi Voicelines - Yumi Haha2.ogg',
    [CHAR_SOUND_HELLO] = {"Yumi Voicelines - Yumi Hello.ogg", "Yumi Voicelines - Yumi Hi.ogg", "Yumi Voicelines - Yumi Hello There.ogg"},
    [CHAR_SOUND_HERE_WE_GO] = {'Yumi Voicelines - Yumi Here We Go.ogg', "Yumi Voicelines - That's Right (Star Get).ogg", "Yumi Voicelines - Yumi It's About Time (Star Get).ogg"},
    [CHAR_SOUND_HOOHOO] = 'Yumi Voicelines - Yumi Double Jump.ogg',
    [CHAR_SOUND_HRMM] = 'Yumi Voicelines - Yumi Hrmm.ogg',
    [CHAR_SOUND_IMA_TIRED] = 'Yumi Voicelines - Yumi Im A Tired.ogg',
    [CHAR_SOUND_LETS_A_GO] = {"Yumi Voicelines - Yumi Let's A Go.ogg", "Yumi Voicelines - Yumi Let's Go 2.ogg"},
    [CHAR_SOUND_MAMA_MIA] = 'Yumi Voicelines - Yumi Mamamia.ogg',
    [CHAR_SOUND_OKEY_DOKEY] = 'Yumi Voicelines - Yumi Okey Dokey.ogg',
    [CHAR_SOUND_PRESS_START_TO_PLAY] = "Yumi Voicelines - Yumi Press Start to Play.ogg",
    [CHAR_SOUND_PUNCH_HOO] = 'Yumi Voicelines - Yumi Single Jump 1.ogg',
    [CHAR_SOUND_PUNCH_WAH] = 'Yumi Voicelines - Yumi Single Jump 2.ogg',
    [CHAR_SOUND_PUNCH_YAH] = 'Yumi Voicelines - Yumi Kick.ogg',
    [CHAR_SOUND_SO_LONGA_BOWSER] = 'Yumi Voicelines - Yumi Hello There.ogg',
    [CHAR_SOUND_TWIRL_BOUNCE] = 'Yumi Voicelines - Yumi Mamamia 2.ogg',
    [CHAR_SOUND_UH] = 'Yumi Voicelines - Yumi Uh 1.ogg',
    [CHAR_SOUND_UH2] = 'Yumi Voicelines - Yumi Uh 2.ogg',
    [CHAR_SOUND_UH2_2] = 'Yumi Voicelines - Yumi Uh 3.ogg',
    [CHAR_SOUND_WAAAOOOW] = 'Yumi Voicelines - Yumi Waaaooow.ogg',
    [CHAR_SOUND_WAH2] = 'Yumi Voicelines - Yumi Single Jump 2.ogg',
    [CHAR_SOUND_WHOA] = 'Yumi Voicelines - Yumi Mamamia 2.ogg',
    [CHAR_SOUND_YAHOO] = 'Yumi Voicelines - Yumi Triple Jump 4 - Long Jump.ogg',
    [CHAR_SOUND_YAHOO_WAHA_YIPPEE] = {'Yumi Voicelines - Yumi Triple Jump 1.ogg', 'Yumi Voicelines - Yumi Triple Jump 2.ogg', 'Yumi Voicelines - Yumi Triple Jump 3.ogg'},
    [CHAR_SOUND_YAH_WAH_HOO] = {'Yumi Voicelines - Yumi Single Jump 1.ogg', 'Yumi Voicelines - Yumi Single Jump 2.ogg', 'Yumi Voicelines - Yumi Kick.ogg'},
}

if charSelectExists then
    character_add("Yumpi", "The tiny (definitely not murderous) version\nof Yumi!\nDespite what people may think she's a different\nentity from Yumi.\nShe has a habit of biting people that get too\nclose from her, so be careful sitting\nnext to her.", "xLuigiGamerx", {r = 90, g = 120, b = 220}, E_MODEL_YUMPI, CT_LUIGI, TEX_YUMPI)

    charSelect.character_add_voice(E_MODEL_YUMPI, VOICETABLE_YUMPI)
    hook_event(HOOK_CHARACTER_SOUND, function (m, sound)
        if charSelect.character_get_voice(m) == VOICETABLE_YUMPI then return charSelect.voice.sound(m, sound) end
    end)
    hook_event(HOOK_MARIO_UPDATE, function (m)
        if charSelect.character_get_voice(m) == VOICETABLE_YUMPI then return charSelect.voice.snore(m) end
    end)
else
    djui_popup_create("\\#ff0000\\\nCharacter Select was not found\nPlease restart your server and enable Character Select to play as the \\#00AAFF\\Tiny Yumi (aka Yumpi)", 6)
end